#!ruby
#
#  TOPPERS ATK2
#      Toyohashi Open Platform for Embedded Real-Time Systems
#      Automotive Kernel Version 2
#
#  Copyright (C) 2011-2015 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
#  Copyright (C) 2011-2013 by Spansion LLC, USA
#  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
#  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
#  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2011-2015 by Witz Corporation
#  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
#  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
#  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: com_port.rb 1801 2015-03-27 06:34:43Z t_ishikawa $
#

# ץ󥹥ȡ롧$ gem install serialport
require "rubygems"
require "serialport"

Thread.abort_on_exception = true

# 1: CORE0Υեå
nOffset = 0
if (ARGV.size() >= 1)
  nOffset = ARGV[0].to_i()
end

# 2: λե饰
bTerminate = false
if (ARGV.size() >= 2)
  bTerminate = ARGV[1]
end


# ctrl+cˤ붯λ
Signal.trap(:SIGINT){
  system("kill -9 #$$")
}


# ݡȽ
PORT_PREFIX = "/dev/ttyS"
aPorts = []
thSearchPort = Thread.new {
  IO.popen("ls -1 #{PORT_PREFIX}*") do |io|
    while io.gets()
      aPorts.push($_.gsub!(PORT_PREFIX, "").gsub!("\n", "").to_i())
    end
  end
}
thSearchPort.join()

# COMݡȤ¸ߤʤϽλ
if (aPorts.empty?())
  puts("COM port is not found.")
  exit(1)
end

nPreNum = -1
nTargetPort = -1
aPorts.sort.reverse.each{|nNumber|
  if (nPreNum == -1)
    nPreNum = nNumber
    # ݡȤ1ĤΤߤäؤб
    nTargetPort = nNumber
  else
    # 礭Ϣ֤ǤʤʤäͤоݥݡȤȤ
    if (!((nPreNum - nNumber) == 1))
      nTargetPort = nPreNum
      break
    else
      nPreNum = nNumber
      # Ϣ֤ȤʤäƤؤб
      nTargetPort = nNumber
    end
  end
}


# CORE0Υեå
nTargetPort += nOffset


# USBޤľؤб
sChk = ""
thUSB = Thread.new {
  while true
    IO.popen("stty -F #{PORT_PREFIX}#{nTargetPort}") do |io|
      while io.gets()
        sChk = $_
      end
    end
    if (!sChk.include?("Invalid argument"))
      break
    end
  end
}
thUSB.join()


cCom = nil
nBaudrate = 921600
thMain = Thread.new {
  puts("\nUsing COM port: #{(nTargetPort+1).to_s()} [#{nBaudrate.to_s()}]")

  cCom = SerialPort.open("/dev/ttyS#{nTargetPort}", nBaudrate, 8, 1, SerialPort::NONE)

  while true
    sLine = cCom.gets()
    print(sLine)
    if (sLine == "Kernel Exit...\n")
      # CORE0⤷Ͻλե饰falseǤʤΤ߽λ
      if ((nOffset == 0) || (bTerminate != false))
        break
      end
    end
  end

  cCom.close()
}


# COMݡ³ctrl+cǶλ뤿Υߡå
thDummy = Thread.new {
  while true
    sleep(1)
  end
}

# 3֤ǥॢ
# (ꥢߤؤн)
result = thMain.join(10800)
if (result.nil?())
  puts("[com_port.rb] timeout!!")
  cCom.close()
end

